
 #if POKEMON_UNEVOLVE==1
 Check_UnEvolve(id, pid)
 {
	new num = HasPokemon(id, pid)
	if(num<0)
		return false

	if( !AnyEvolveTo(pid) )
		return false

	new poke_that_evolves = 0;
	while( poke_that_evolves < TOTAL_POKES && !EvolveToThis(poke_that_evolves, pid) )
		poke_that_evolves++;

	new evolve = EvolveTo(poke_that_evolves, pid)

	new level = PlayersLevel(id, num)
	if( evolve >= 0 && level < evolve ){
		new name[32], pname1[NAME_LENGTH], pname2[NAME_LENGTH]
		get_user_name(id, name, 31)
		PokeToName(pid, pname1)
		PokeToName(poke_that_evolves, pname2)
		client_print(id, print_chat, "%s %s, %s has reverted to a %s.",PREFIX,name,pname1,pname2)
		PlayersPoke[id][num] = poke_that_evolves
		RefreshPoke(id)

		return true
	}

	return false
 }
 EvolveTo(pid, this)
 {
	for(new i=0; i<MAX_EVOLVES; i++)
		if(PokeEvolveTo[i][pid]==this)
			return EvolveAtNum(pid, i)
	return 0
 }
 #endif
 
 Check_Evolve(id, pid, level=-1)
 {
	#if POKEMON_UNEVOLVE==1
	if(Check_UnEvolve(id, pid))
		return false
	#endif

	if(!EvoPoke(pid) || HasPokemon(id, pid, true)<0){
		return false
	}
	if(level==-1)
		level = PlayersLevel(id, HasPokemon(id,pid))

	new evolves_at = EvolveAt(pid, level)
	if(evolves_at > -1)
	{
		new name[32],pname1[NAME_LENGTH],pname2[NAME_LENGTH], pnum = HasPokemon(id, pid, true)
		get_user_name(id, name, 31)
		PokeToName(pid, pname1)
		PlayersPoke[id][pnum] = PokeEvolveTo[evolves_at][pid]
		if(pnum==PlayersActive[id])
			Pokemon[id] = PlayersPoke[id][pnum]
		PokeToName(PlayersPoke[id][pnum], pname2)
		client_print(0, print_chat, "%s Congratulations %s! %s has evolved into %s.",PREFIX,name,pname1,pname2)

		return true
	}
	return false
 }
 
 Check_Stone_Evolve(id, pid, item)
 {
	if(!EvoPoke(pid) || HasPokemon(id, pid, true)<0){
		return false
	}
	new iname[NAME_LENGTH], pname1[NAME_LENGTH]
	PokeToName(pid, pname1)
	ItemToName(item, iname)

	Item[id][item]--
	client_print(id, print_chat, "%s You gave %s a %s.",PREFIX,pname1,iname)

	new evolves_at = EvolveAt(pid, -1*item)
	if(evolves_at > -1)
	{
		new pnum = HasPokemon(id, pid, true)
		if(PokeChance(id, pnum)){
			new name[32], pname2[NAME_LENGTH]
			get_user_name(id, name, 31)
			PlayersPoke[id][pnum] = PokeEvolveTo[evolves_at][pid]
			if(pnum==PlayersActive[id])
				Pokemon[id] = PlayersPoke[id][pnum]
			PokeToName(PlayersPoke[id][pnum], pname2)
			client_print(0, print_chat, "%s Congratulations %s! %s has evolved into %s.",PREFIX,name,pname1,pname2)
			return true
		}
		else{
			client_print(id, print_chat, "%s %s took the %s and threw it away.",PREFIX,pname1,iname)
		}
	}
	else
		client_print(id, print_chat, "%s %s does not like %ss.",PREFIX,pname1,iname)
	return false
 }
 Check_Trade_Evolve(id, pid)
 {
	if(!EvoPoke(pid) || HasPokemon(id, pid, true)<0){
		return false
	}
	new evolves_at = EvolveAt(pid, TRADE_EVOLVE)
	if(evolves_at > -1)
	{
		new pnum = HasPokemon(id, pid, true)
		new pname1[NAME_LENGTH]
		PokeToName(pid, pname1)

		if(PokeChance(id, pnum)){
			new name[32], pname2[NAME_LENGTH], pnum = HasPokemon(id, pid, true)
			get_user_name(id, name, 31)
			PlayersPoke[id][pnum] = PokeEvolveTo[evolves_at][pid]
			if(pnum==PlayersActive[id])
				Pokemon[id] = PlayersPoke[id][pnum]
			PokeToName(PlayersPoke[id][pnum], pname2)
			client_print(0, print_chat, "%s Congratulations %s! %s has evolved into %s.",PREFIX,name,pname1,pname2)
			return true
		}
		else{
			new temp[51]
			switch(random(5))
			{
				case 0:
					copy(temp, 50, "growls at you")
				case 1:
					copy(temp, 50, "smiles at you")
				case 2:
					copy(temp, 50, "looks at you oddly")
				case 3:
					copy(temp, 50, "likes you")
				case 4:
					copy(temp, 50, "jumps on you")
			}
			client_print(id, print_chat, "%s %s %s.",PREFIX,pname1,temp)
		}
	}
	return false
 }
 AnyEvolveTo(pid)
 {
	new i,k;
	for(k=0; k<TOTAL_POKES; k++)
	for(i=0; i<MAX_EVOLVES; i++)
		if(PokeEvolveTo[i][k]==pid)
			return k
	return 0
 }
 LevelEvolve(pid)
 {
	new low, evolve
	for(new i=0; i<MAX_EVOLVES; i++)
	{
		evolve = EvolveAtNum(pid, i)
		if(evolve > 0 && ( evolve < low || !low ) )
			low = evolve
	}
	return low
 }
 OtherEvolve(pid)
 {
	new low, evolve
	for(new i=0; i<MAX_EVOLVES; i++)
	{
		evolve = EvolveAtNum(pid, i)
		if(evolve < 0 && ( evolve < low || !low ) )
			low = evolve
	}
	return low
 }
 EvolveAt(pid, this)
 {
	for(new i=0; i<MAX_EVOLVES; i++)
		if( EvolveAtNum(pid, i)==this
		|| (EvolveAtNum(pid, i) > 0 && this > EvolveAtNum(pid, i)) )
			return i
	return -1
 }
 EvolveAtNum(pid, num)
 {
	return PokeEvolve[num][pid]
 }


